SystemOrganization addCategory: #'OmniVMNoOpt-Core-Reflection-Tests'!
SystemOrganization addCategory: #'OmniVMNoOpt-Core-Reflection'!
SystemOrganization addCategory: #'OmniVMNoOpt-Core-Misc'!
SystemOrganization addCategory: #'OmniVMNoOpt-Transporter'!

TestCase subclass: #OstTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Misc'!

OstTestCase subclass: #ONOCompilerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection-Tests'!

!ONOCompilerTest methodsFor: 'helper' stamp: 'StefanMarr 7/19/2012 22:56'!
methodWithOmniMetaExit
	<omniUnenforced>
	^ self! !

!ONOCompilerTest methodsFor: 'helper' stamp: 'StefanMarr 3/10/2012 19:47'!
methodWithoutAnyPragma
	^ self! !

!ONOCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 8/2/2012 14:26'!
testMethodsCompiledProperly
	"Make sure that all methods have been compiled properly
	with the method flag set when <omniUnenforced> is present.
	
	If this test fails, make sure ONOCompilerSupport>>#resetMethodFlagForOmniUnenforced is executed."
	| withOmniUnenforced |
	withOmniUnenforced := CompiledMethod allInstances 
			select: [:m | (m pragmaAt: #omniUnenforced) notNil].
	
	
	self assert: 0 equals: ((withOmniUnenforced select: [:m | m flag not ]) size).! !

!ONOCompilerTest methodsFor: 'tests' stamp: 'StefanMarr 3/10/2012 19:49'!
testOmniMetaExitMethodFlag
	"IMPORTANT: we assume the code has be already compiled with a suitable compiler"
	
	self assert: (self class >> #methodWithoutAnyPragma) flag not.
	
	self assert: (self class >> #methodWithOmniMetaExit) flag.! !

OstTestCase subclass: #ONODomainCustomizationConstTest
	instanceVariableNames: ''
	classVariableNames: 'SomeClassVar'
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection-Tests'!

!ONODomainCustomizationConstTest methodsFor: 'tests' stamp: 'StefanMarr 7/31/2012 22:36'!
testReadField
	| customIndication domain subject |
	"first create domain and restrict customization to reading of fields"
	customIndication := 0 	bitAt: (ONOMirror encodingBitFor: #readField:of:)
							put: 1.
	domain := ONOTestDomain new.
	domain instVarNamed: #domainCustomizations put: customIndication.
	
	"now create a subject"
	subject := ONOTestObject new.
	domain adoptObject: subject.
	domain target: subject.
	
	[subject a: false.
	 subject a.
	 SomeClassVar := false.
	 SomeClassVar] omni: domain.

	self assert: 1 equals: domain readCountA.
	self assert: 0 equals: domain readCountB.
	self assert: 0 equals: domain readLiteral size.
	self assert: 0 equals: domain requestedSelectors size.
	self assert: 0 equals: domain writeCountA.
	self assert: 0 equals: domain writeCountB.
	self assert: nil equals: domain writtenLiteral.
! !

!ONODomainCustomizationConstTest methodsFor: 'tests' stamp: 'StefanMarr 7/31/2012 22:40'!
testReadLiteral
	| customIndication domain subject |
	"first create domain and restrict customization to reading of fields"
	customIndication := 0 	bitAt: (ONOMirror encodingBitFor: #readLiteral:)
							put: 1.
	domain := ONOTestDomain new.
	domain instVarNamed: #domainCustomizations put: customIndication.
	
	"now create a subject"
	subject := ONOTestObject new.
	domain adoptObject: subject.
	domain target: subject.
	
	[subject a: false.
	 subject a.
	 SomeClassVar := false.
	 SomeClassVar] omni: domain.

	self assert: 0 equals: domain readCountA.
	self assert: 0 equals: domain readCountB.
	self assert: 1 equals: domain readLiteral size.
	self assert: #SomeClassVar equals: domain readLiteral first key.
	self assert: 0 equals: domain requestedSelectors size.
	self assert: 0 equals: domain writeCountA.
	self assert: 0 equals: domain writeCountB.
	self assert: nil equals: domain writtenLiteral.! !

!ONODomainCustomizationConstTest methodsFor: 'tests' stamp: 'StefanMarr 7/31/2012 22:36'!
testWriteField
	| customIndication domain subject |
	"first create domain and restrict customization to reading of fields"
	customIndication := 0 	bitAt: (ONOMirror encodingBitFor: #write:toField:of:)
							put: 1.
	domain := ONOTestDomain new.
	domain instVarNamed: #domainCustomizations put: customIndication.
	
	"now create a subject"
	subject := ONOTestObject new.
	domain adoptObject: subject.
	domain target: subject.
	
	[subject a: false.
	 subject a.
	 SomeClassVar := false.
	 SomeClassVar] omni: domain.

	self assert: 0 equals: domain readCountA.
	self assert: 0 equals: domain readCountB.
	self assert: 0 equals: domain readLiteral size.
	self assert: 0 equals: domain requestedSelectors size.
	self assert: 1 equals: domain writeCountA.
	self assert: 0 equals: domain writeCountB.
	self assert: nil equals: domain writtenLiteral.! !

!ONODomainCustomizationConstTest methodsFor: 'tests' stamp: 'StefanMarr 7/31/2012 22:40'!
testWriteLiteral
	| customIndication domain subject |
	"first create domain and restrict customization to reading of fields"
	customIndication := 0 	bitAt: (ONOMirror encodingBitFor: #write:toLiteral:)
							put: 1.
	domain := ONOTestDomain new.
	domain instVarNamed: #domainCustomizations put: customIndication.
	
	"now create a subject"
	subject := ONOTestObject new.
	domain adoptObject: subject.
	domain target: subject.
	
	[subject a: false.
	 subject a.
	 SomeClassVar := false.
	 SomeClassVar] omni: domain.

	self assert: 0 equals: domain readCountA.
	self assert: 0 equals: domain readCountB.
	self assert: 0 equals: domain readLiteral size.
	self assert: 0 equals: domain requestedSelectors size.
	self assert: 0 equals: domain writeCountA.
	self assert: 0 equals: domain writeCountB.
	self assert: #SomeClassVar equals: domain writtenLiteral key.! !

OstTestCase subclass: #ONODomainTest
	instanceVariableNames: ''
	classVariableNames: 'SomeClassVar'
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection-Tests'!

!ONODomainTest methodsFor: 'test helper' stamp: 'StefanMarr 3/14/2012 10:35'!
helperExecuteAllMessages: o
	self assert: #a equals: o a.
	self assert: #b equals: o b.
	self assert: nil equals: o magicNil.
	self assert: 1 equals: o magicOne.
	self assert: o equals: o magicSelf.
	self assert: 'ab' equals: o ab.
	
	o b: #bb.
	self assert: #bb equals: o b.
	
	o a: #aa.
	self assert: #aa equals: o a. 
	
	o makeOne.
	self assert: 1 equals: o b.! !

!ONODomainTest methodsFor: 'test helper' stamp: 'StefanMarr 11/12/2011 21:33'!
helperExecuteAllMessagesSimple: o
	o a.
	o b.
	o magicNil.
	o magicOne.
	o magicSelf.
	o ab.
	o b: #bb.
	o a: #aa.
	o makeOne.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/13/2012 19:22'!
testAdopt
	| o d |
	o := Object new.
	d := OstDomain new.
	
	self assert: nil equals: (ONOMirror domainOf: o).
	
	d adoptObject: o.
	
	self assert: d equals: (ONOMirror domainOf: o).! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 4/14/2012 17:53'!
testClass
	| d o c |
	d := ONOTestDomain new.
	o := ONOTestObject new.
	d adoptObject: o.
	
	c := [o class] omni: d.
	
	self assert: ONOTestObject equals: c.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 4/14/2012 18:00'!
testClone
	| d o clone |
	d := ONOTestDomain new.
	o := ONOTestObject new.
	d adoptObject: o.
	
	clone := [o copy] omni: d.
	
	self assert: d equals: (OstMirror domainOf: clone).! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 7/20/2012 22:21'!
testCorrectDomainUsedForEnforcement
        | o d1 d2 |
        o := ONOTestObjectSub new.
        
        d1 := ONORWTestDomain new.
        d2 := ONORWTestDomain new.
        
        d1 adoptObject: o.
        d1 target: o.
        
        [ o a ] omni: d2.
        
        self assert: #a  equals: d1 lastSuperSelector.
        self assert: nil equals: d2 lastSuperSelector.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/13/2012 21:56'!
testDomainForNewObjectsInitialization
	| domain |
	domain := ONOTestDomain new.
	self assert: domain equals: domain domainForNewObjects.
	
	self assert: domain equals: (domain instVarNamed: #domainForNewObjects).! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 4/22/2012 14:11'!
testLiteralReadWithDomain
	| d read |
	d := ONOTestDomain new.
	
	read := [ ONODomainTest ] omni: d.

	self assert: ONODomainTest equals: read.
	self assert: (Smalltalk associationAt: #ONODomainTest) equals: d readLiteral first.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 4/22/2012 16:17'!
testLiteralWriteWithDomain
	| d read |
	d := ONOTestDomain new.
	
	SomeClassVar := nil.
	
	read := [ SomeClassVar := #foo ] omni: d.

	self assert: read equals: #foo.
	self assert: SomeClassVar equals: #foo.
	self assert: d writtenLiteral equals: (ONODomainTest bindingOf: #SomeClassVar).! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/17/2012 12:39'!
testReadWithDomain
	| o d |
	o := ONOTestObject new.
	d := ONOTestDomain new.
	d adoptObject: o.
	d target: o.
	
	[self helperExecuteAllMessages: o ] omni: d.

	self assert: 3 equals: d readCountA.
	self assert: 4 equals: d readCountB.
	
	self assert: 1 equals: d writeCountA.
	self assert: 2 equals: d writeCountB.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 4/22/2012 17:45'!
testRequestExecWithDomain
	| o d expectedSelectors |
	o := ONOTestObject new.
	d := ONOTestDomain new.
	d adoptObject: o.
	d target: o.
	
	expectedSelectors := ONOTestObject selectors reject: [:sel | sel = #initialize].
	
	[self helperExecuteAllMessages: o ] omni: d.

	"All selectors that are expected should already be in that set, and then there are a few more
	 which actually got recorded because of the implementation details of the methods executed"
	self assert: (d requestedSelectors union: expectedSelectors) equals: d requestedSelectors.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/17/2012 12:40'!
testSimpleReadWithDomain
	| o d |
	o := ONOTestObject new.
	d := ONORWTestDomain new.
	d adoptObject: o.
	d target: o.
	
	[ o a ] omni: d.

	self assert: 1 equals: d readCountA.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/21/2012 15:40'!
testSimpleSuperSendWithDomain
	| o d |
	o := ONOTestObjectSub new.
	d := ONORWTestDomain new.
	d adoptObject: o.
	d target: o.
	
	[ o a ] omni: d.
 
	self assert: #a equals: d lastSuperSelector.
	self assert: 1 equals: d readCountA.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 3/17/2012 14:39'!
testSimpleWriteWithDomain
	| o d |
	o := ONOTestObject new.
	d := ONORWTestDomain new.
	d adoptObject: o.
	d target: o.
	
	[ o a: #bbb ] omni: d.

	self assert: 1 equals: d writeCountA.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 8/4/2012 15:30'!
testSpecialSendBytecode
	| o d r |
	o := ONOTestObjectSub new.
	o initForTestSpecialSendBytecode.
	d := OstDomain new.
	d adoptObject: o.
	
	r := [ o next ] omni: d.

	self assert: 1 equals: o a.
	self assert: #first equals: r.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 4/1/2012 21:54'!
testTimesRepeat
	| o d r |
	o := ONOTestObjectSub new.
	o initForTimesRepeat.
	d := OstDomain new.
	d adoptObject: o.
	
	r := [ o repeat: 4 on: o ] omni: d.

	self assert: 4 equals: o c.
	o collection do: [:execOnBase |
		self assert: execOnBase].
! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 4/22/2012 17:45'!
testWithDomain
	| o d expectedSelectors |
	o := ONOTestObject new.
	d := ONOTestDomain new.
	d adoptObject: o.
	d target: o.
	
	expectedSelectors := ONOTestObject selectors asOrderedCollection reject: [:sel | sel = #initialize].
	expectedSelectors add: #=.
	
	[self helperExecuteAllMessages: o ] omni: d.
	
	"All selectors that are expected should already be in that set, and then there are a few more
	 which actually got recorded because of the implementation details of the methods executed"
	self assert: (d requestedSelectors union: expectedSelectors) equals: d requestedSelectors.
	
	self assert: 3 equals: d readCountA.
	self assert: 4 equals: d readCountB.
	
	self assert: 1 equals: d writeCountA.
	self assert: 2 equals: d writeCountB.! !

!ONODomainTest methodsFor: 'tests' stamp: 'StefanMarr 11/11/2011 00:35'!
testWithNilDomain
	| o |
	o := ONOTestObject new.
	self helperExecuteAllMessages: o.! !

OstTestCase subclass: #ONOMirrorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection-Tests'!

!ONOMirrorTest methodsFor: 'helpers' stamp: 'StefanMarr 7/19/2012 22:56'!
onMetaLevel
	<omniUnenforced>
	^ ONOMirror executesOnMetaLevel! !

!ONOMirrorTest methodsFor: 'helpers' stamp: 'StefanMarr 3/10/2012 19:51'!
onSomeLevelNoPragma
	^ ONOMirror executesOnMetaLevel! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/15/2012 15:14'!
testBaselevelPerform
	self assert: ONOMirror executesOnMetaLevel.
	
	self assert: (self baselevelPerform: #onSomeLevelNoPragma) not.
	
	self assert: ONOMirror executesOnMetaLevel.! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/14/2012 15:33'!
testBaselevelPerformWithArguments
	self assert: ONOMirror executesOnMetaLevel.
	
	self assert: (self baselevelPerform: #onSomeLevelNoPragma withArguments: #()) not.
	
	self assert: ONOMirror executesOnMetaLevel.! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/14/2012 15:34'!
testBaselevelPerformWithArgumentsInSuperclass
	self assert: ONOMirror executesOnMetaLevel.
	
	self assert: (self baselevelPerform: #onSomeLevelNoPragma withArguments: #() inSuperclass: self class) not.
	
	self assert: ONOMirror executesOnMetaLevel.! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/12/2012 22:56'!
testBlockBaseLevel
	| d baseLevel |
	d := OstDomain new.
	
	baseLevel := [ ONOMirror executesOnBaseLevel ] omni: d.
	
	self assert: baseLevel.
	
	! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/12/2012 22:58'!
testBlockBaseLevelValueWithArgs
	| baseLevel |
	
	ONOMirror switchToBaseLevel.
	
	baseLevel := [:i | ONOMirror executesOnBaseLevel ] value: 1.
	
	ONOMirror switchToMetaLevel.
	
	self assert: baseLevel.
	
	! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 7/29/2012 18:38'!
testCustomizationConstantIsConsistent
	"self checkConsistencyForAllDomains"
	OstDomain allSubclassesDo: [:c |
		self assert: (ONOMirror customizationConstIsConstistentFor: c).
	].! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 7/29/2012 18:37'!
testDomainDefinitionsLookConsistent
	self shouldnt: [ONOMirror checkConsistencyForAllDomains] raise: Warning! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 7/31/2012 21:40'!
testEncodingForSelectorReadField
	| bit encoding encodedSelectors |
	bit := ONOMirror encodingBitFor: #readField:of:.
	encoding := 0 bitAt: bit put: 1.
	
	encodedSelectors := ONOMirror encodedCustomizations: encoding.
	self assert: 1 equals: encodedSelectors size.
	self assert: #readField:of: equals: encodedSelectors first.! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 7/31/2012 21:41'!
testEncodingForSelectorReadLiteral
	| bit encoding encodedSelectors |
	bit := ONOMirror encodingBitFor: #readLiteral:.
	encoding := 0 bitAt: bit put: 1.
	
	encodedSelectors := ONOMirror encodedCustomizations: encoding.
	self assert: 1 equals: encodedSelectors size.
	self assert: #readLiteral: equals: encodedSelectors first.! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 7/31/2012 21:41'!
testEncodingForSelectorWriteToFieldOf
	| bit encoding encodedSelectors |
	bit := ONOMirror encodingBitFor: #write:toField:of: .
	encoding := 0 bitAt: bit put: 1.
	
	encodedSelectors := ONOMirror encodedCustomizations: encoding.
	self assert: 1 equals: encodedSelectors size.
	self assert: #write:toField:of: equals: encodedSelectors first.! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 7/31/2012 21:41'!
testEncodingForSelectorWriteToLiteral
	| bit encoding encodedSelectors |
	bit := ONOMirror encodingBitFor: #write:toLiteral:.
	encoding := 0 bitAt: bit put: 1.
	
	encodedSelectors := ONOMirror encodedCustomizations: encoding.
	self assert: 1 equals: encodedSelectors size.
	self assert: #write:toLiteral: equals: encodedSelectors first.! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/12/2012 21:46'!
testMetaExitPragma
	| onBaseLvl1 onBaseLvl2 onMetaLvl |
	self assert: ONOMirror executesOnMetaLevel.
	
	self assert: self onMetaLevel.
	
	self assert: self onSomeLevelNoPragma.
	
	ONOMirror switchToBaseLevel.
	
	"We post-pone the asserts to not run into trouble with SUnit and the tests."
	onBaseLvl1 := self onSomeLevelNoPragma not.
	onMetaLvl := self onMetaLevel.
	onBaseLvl2 := self onSomeLevelNoPragma not.
	
	ONOMirror switchToMetaLevel.
	
	self assert: onBaseLvl1.
	self assert: onMetaLvl.
	self assert: onBaseLvl2.
	
	self assert: ONOMirror executesOnMetaLevel.! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/13/2012 11:27'!
testOmniBlockThisContext
	| d  execD |
	d := OstDomain new.
	
	execD := [ ONOMirror domainOf: thisContext ] omni: d.
	
	self assert: d equals: execD.! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/10/2012 18:33'!
testPrimitiveGetSetDomain
	| o d |
	o := Object new.
	
	self assert: nil equals: (ONOMirror domainOf: o).
	 
	d := Object new.
	ONOMirror setDomainOf: o to: d.
	self assert: d equals: (ONOMirror domainOf: o).! !

!ONOMirrorTest methodsFor: 'tests' stamp: 'StefanMarr 3/12/2012 21:49'!
testSwitchExecLevel
	| baseLevel |
	self assert: ONOMirror executesOnMetaLevel.
	
	ONOMirror switchToBaseLevel.
	
	baseLevel := ONOMirror executesOnBaseLevel.
	ONOMirror switchToMetaLevel.
	
	self assert: baseLevel.
	self assert: ONOMirror executesOnMetaLevel.! !

OstTestCase subclass: #ONOWriteTest
	instanceVariableNames: 'value fieldIdx targetObj returnValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection-Tests'!

!ONOWriteTest methodsFor: 'handcrafted bytecodes' stamp: 'StefanMarr 8/3/2012 19:11'!
prepareHandcraftedDoAnythingUsingTop
	| cm |
	cm := ONOWriteObject >> #storeAndPopDoAnythingUsingTopHandcrafted:.
	
	self assert: 27 equals: cm size.
	self assert: 17 equals: cm initialPC.
	
	"The original bytecodes"
	((cm at: 17) = 16 and: [
	 (cm at: 18) = 132 and: [
	 (cm at: 19) = 192 and: [
	 (cm at: 20) = 69 and: [
	 (cm at: 21) = 32]]]]) ifTrue: [
		"Now reordering the pushConstant to be first"
		cm at: 17 put: 32.
		cm at: 18 put: 16.
		cm at: 19 put: 132.
		cm at: 20 put: 192.
		cm at: 21 put: 69.
	].

	self assert: 32 		equals: (cm at: 17).
	self assert: 16 		equals: (cm at: 18).
	self assert: 132 	equals: (cm at: 19).
	self assert: 192 	equals: (cm at: 20).
	self assert: 69 		equals: (cm at: 21).! !

!ONOWriteTest methodsFor: 'handcrafted bytecodes' stamp: 'StefanMarr 8/3/2012 19:10'!
prepareHandcraftedExtendedUsingTop
	| cm |
	cm := ONOWriteObject >> #storeAndPopExtendedUsingTopHandcrafted:.
	
	self assert: 26 equals: cm size.
	self assert: 17 equals: cm initialPC.
	
	"The original bytecodes"
	((cm at: 17) = 16 and: [
	 (cm at: 18) = 130 and: [
	 (cm at: 19) = 9 and: [
	 (cm at: 20) = 32]]]) ifTrue: [
		"Now reordering the pushConstant to be first"
		cm at: 17 put: 32.
		cm at: 18 put: 16.
		cm at: 19 put: 130.
		cm at: 20 put: 9.
	].

	self assert: 32 equals: (cm at: 17).
	self assert: 16 equals: (cm at: 18).
	self assert: 130 equals: (cm at: 19).
	self assert: 9 equals: (cm at: 20).! !

!ONOWriteTest methodsFor: 'handcrafted bytecodes' stamp: 'StefanMarr 8/3/2012 19:09'!
prepareHandcraftedUsingTop
	| cm |
	cm := ONOWriteObject >> #storeAndPopUsingTopHandcrafted:.
	
	self assert: 25 equals: cm size.
	self assert: 17 equals: cm initialPC.
	
	"The original bytecodes"
	((cm at: 17) = 16 and: [
	 (cm at: 18) = 96 and: [
	 (cm at: 19) = 32]]) ifTrue: [
		"Now reordering the pushConstant to be first"
		cm at: 17 put: 32.
		cm at: 18 put: 16.
		cm at: 19 put: 96.
	].

	self assert: 32 equals: (cm at: 17).
	self assert: 16 equals: (cm at: 18).
	self assert: 96 equals: (cm at: 19).! !

!ONOWriteTest methodsFor: 'tests - store and pop' stamp: 'StefanMarr 8/3/2012 19:07'!
testPop
	| o result domain |
	domain := ONOWriteTestDomain new.
	
	[ o := ONOWriteObject new.
	result := o storeAndPop: 13. ] omni: domain.

	self assert: o equals: result.
	
	self assert: 1 			equals: domain fieldIdx.
	self assert: o 			equals: domain targetObj.
	self assert: 13 			equals: domain value.
	self assert: 13 	equals: domain returnValue.! !

!ONOWriteTest methodsFor: 'tests - store and pop' stamp: 'StefanMarr 8/3/2012 19:07'!
testPopDoAnything
	| o result domain |
	domain := ONOWriteTestDomain new.
	
	[ o := ONOWriteObject new.
	result := o storeAndPopDoAnything: 13. ] omni: domain.

	self assert: o equals: result.
	
	self assert: 70 			equals: domain fieldIdx.
	self assert: o 			equals: domain targetObj.
	self assert: 13 			equals: domain value.
	self assert: 13 	equals: domain returnValue.! !

!ONOWriteTest methodsFor: 'tests - store and pop' stamp: 'StefanMarr 8/3/2012 19:29'!
testPopDoAnythingHandcrafted
	| o result domain |
	self prepareHandcraftedDoAnythingUsingTop.
	
	domain := ONOWriteTestDomain new.
	
	[ o := ONOWriteObject new.
	result := o storeAndPopDoAnythingUsingTopHandcrafted: 13. ] omni: domain.

	self assert: 42 equals: result.
	
	self assert: 70 	equals: domain fieldIdx.
	self assert: o 	equals: domain targetObj.
	self assert: 13 	equals: domain value.
	self assert: 42 	equals: domain returnValue.! !

!ONOWriteTest methodsFor: 'tests - store and pop' stamp: 'StefanMarr 8/3/2012 19:08'!
testPopExtended
	| o result domain |
	domain := ONOWriteTestDomain new.
	
	[ o := ONOWriteObject new.
	result := o storeAndPopExtended: 13. ] omni: domain.

	self assert: o equals: result.
	
	self assert: 10 			equals: domain fieldIdx.
	self assert: o 			equals: domain targetObj.
	self assert: 13 			equals: domain value.
	self assert: 13 	equals: domain returnValue.! !

!ONOWriteTest methodsFor: 'tests - store and pop' stamp: 'StefanMarr 8/3/2012 19:30'!
testPopExtendedHandcrafted
	| o result domain |
	self prepareHandcraftedExtendedUsingTop.
	
	domain := ONOWriteTestDomain new.
	
	[ o := ONOWriteObject new.
	result := o storeAndPopExtendedUsingTopHandcrafted: 13. ] omni: domain.

	self assert: 42 equals: result.
	
	self assert: 10 	equals: domain fieldIdx.
	self assert: o 	equals: domain targetObj.
	self assert: 13	equals: domain value.
	self assert: 42 	equals: domain returnValue.! !

!ONOWriteTest methodsFor: 'tests - store and pop' stamp: 'StefanMarr 8/3/2012 19:30'!
testPopHandcrafted
	| o result domain |
	self prepareHandcraftedUsingTop.
	
	domain := ONOWriteTestDomain new.
	
	[ o := ONOWriteObject new.
	result := o storeAndPopUsingTopHandcrafted: 13. ] omni: domain.

	self assert: 42 equals: result.
	
	self assert: 1 	equals: domain fieldIdx.
	self assert: o 	equals: domain targetObj.
	self assert: 13 	equals: domain value.
	self assert: 42 	equals: domain returnValue.! !

!ONOWriteTest methodsFor: 'tests - store without pop' stamp: 'StefanMarr 8/3/2012 19:06'!
testStore
	| o result domain |
	domain := ONOWriteTestDomain new.
	
	[ o := ONOWriteObject new.
	result := o storeWithoutPop: 13. ] omni: domain.

	self assert: 13 equals: result.
	
	self assert: 1 	equals: domain fieldIdx.
	self assert: o 	equals: domain targetObj.
	self assert: 13 	equals: domain value.
	self assert: #noReturn 	equals: domain returnValue.! !

!ONOWriteTest methodsFor: 'tests - store without pop' stamp: 'StefanMarr 8/3/2012 19:06'!
testStoreDoAnything
	| o result domain |
	domain := ONOWriteTestDomain new.
	
	[ o := ONOWriteObject new.
	result := o storeWithoutPopDoAnything: 13. ] omni: domain.

	self assert: 13 equals: result.
	
	self assert: 70 	equals: domain fieldIdx.
	self assert: o 	equals: domain targetObj.
	self assert: 13 	equals: domain value.
	self assert: #noReturn 	equals: domain returnValue.! !

!ONOWriteTest methodsFor: 'tests - store without pop' stamp: 'StefanMarr 8/3/2012 19:06'!
testStoreDoAnythingPostAdd
	| o result domain |
	domain := ONOWriteTestDomain new.
	
	[ o := ONOWriteObject new.
	result := o storeWithoutPopDoAnythingPostAdd: 13. ] omni: domain.

	self assert: 13 + 42 equals: result.
	
	self assert: 70 	equals: domain fieldIdx.
	self assert: o 	equals: domain targetObj.
	self assert: 13 	equals: domain value.
	self assert: #noReturn 	equals: domain returnValue.! !

!ONOWriteTest methodsFor: 'tests - store without pop' stamp: 'StefanMarr 8/3/2012 19:06'!
testStoreDoAnythingPreAdd
	| o result domain |
	domain := ONOWriteTestDomain new.
	
	[ o := ONOWriteObject new.
	result := o storeWithoutPopDoAnythingPreAdd: 13. ] omni: domain.

	self assert: 13 + 42 equals: result.
	
	self assert: 70 	equals: domain fieldIdx.
	self assert: o 	equals: domain targetObj.
	self assert: 13 	equals: domain value.
	self assert: #noReturn 	equals: domain returnValue.! !

!ONOWriteTest methodsFor: 'tests - store without pop' stamp: 'StefanMarr 8/3/2012 19:06'!
testStoreExtended
	| o result domain |
	domain := ONOWriteTestDomain new.
	
	[ o := ONOWriteObject new.
	result := o storeWithoutPopExtended: 13. ] omni: domain.

	self assert: 13 equals: result.
	
	self assert: 10 	equals: domain fieldIdx.
	self assert: o 	equals: domain targetObj.
	self assert: 13 	equals: domain value.
	self assert: #noReturn 	equals: domain returnValue.! !

!ONOWriteTest methodsFor: 'tests - store without pop' stamp: 'StefanMarr 8/3/2012 19:07'!
testStoreExtendedPostAdd
	| o result domain |
	domain := ONOWriteTestDomain new.
	
	[ o := ONOWriteObject new.
	result := o storeWithoutPopExtendedPostAdd: 13. ] omni: domain.

	self assert: 13 + 42 equals: result.
	
	self assert: 10 	equals: domain fieldIdx.
	self assert: o 	equals: domain targetObj.
	self assert: 13 	equals: domain value.
	self assert: #noReturn 	equals: domain returnValue.! !

!ONOWriteTest methodsFor: 'tests - store without pop' stamp: 'StefanMarr 8/3/2012 19:07'!
testStoreExtendedPreAdd
	| o result domain |
	domain := ONOWriteTestDomain new.
	
	[ o := ONOWriteObject new.
	result := o storeWithoutPopExtendedPreAdd: 13. ] omni: domain.

	self assert: 13 + 42 equals: result.
	
	self assert: 10 	equals: domain fieldIdx.
	self assert: o 	equals: domain targetObj.
	self assert: 13 	equals: domain value.
	self assert: #noReturn 	equals: domain returnValue.! !

!ONOWriteTest methodsFor: 'tests - store without pop' stamp: 'StefanMarr 8/3/2012 19:07'!
testStorePostAdd
	| o result domain |
	domain := ONOWriteTestDomain new.
	
	[ o := ONOWriteObject new.
	result := o storeWithoutPopPostAdd: 13. ] omni: domain.

	self assert: 13 + 42 equals: result.
	
	self assert: 1 	equals: domain fieldIdx.
	self assert: o 	equals: domain targetObj.
	self assert: 13 	equals: domain value.
	self assert: #noReturn 	equals: domain returnValue.! !

!ONOWriteTest methodsFor: 'tests - store without pop' stamp: 'StefanMarr 8/3/2012 19:07'!
testStorePreAdd
	| o result domain |
	domain := ONOWriteTestDomain new.
	
	[ o := ONOWriteObject new.
	result := o storeWithoutPopPreAdd: 13. ] omni: domain.

	self assert: 13 + 42 equals: result.
	
	self assert: 1 	equals: domain fieldIdx.
	self assert: o 	equals: domain targetObj.
	self assert: 13 	equals: domain value.
	self assert: #noReturn 	equals: domain returnValue.! !

!OstTestCase methodsFor: 'running' stamp: 'StefanMarr 7/29/2012 00:37'!
tearDown
	ONOMirror reenableScheduling.
	^ super tearDown! !

!ZeroDivide class methodsFor: '*OmniVMNoOpt-Core-Misc' stamp: 'StefanMarr 7/19/2012 22:53'!
dividend: argument
	<omniUnenforced>
	^self new dividend: argument; yourself! !

!Exception methodsFor: '*OmniVMNoOpt-Core-signaling' stamp: 'StefanMarr 7/19/2012 22:54'!
signal
	"Ask ContextHandlers in the sender chain to handle this signal.  The default is to execute and return my defaultAction."
	<omniUnenforced>

	signalContext := thisContext contextTag.
	signaler ifNil: [ signaler := self receiver ].
	^ signalContext nextHandlerContext handleSignal: self! !

!Exception methodsFor: '*OmniVMNoOpt-Core-signaling' stamp: 'StefanMarr 7/19/2012 22:54'!
signal: signalerText
	"Signal the occurrence of an exceptional condition with a specified textual description."
	<omniUnenforced>
	self messageText: signalerText.
	^ self signal! !

!BlockClosure methodsFor: '*OmniVMNoOpt-Core-Reflection' stamp: 'StefanMarr 3/20/2012 16:13'!
omni
	"Convenience method for testing, not really useful in general"
	^ self omni: OstDomain new! !

!BlockClosure methodsFor: '*OmniVMNoOpt-Core-Reflection' stamp: 'StefanMarr 3/19/2012 14:27'!
omni: aDomain
	"Move to language/baselevel and in the context of the given domain"
	^ aDomain evaluateInContextOnBaseLevel: self! !

!UndefinedObject methodsFor: '*OmniVMNoOpt-Core-Reflection' stamp: 'StefanMarr 3/20/2012 16:25'!
evaluateInContextOnBaseLevel: aBlock
	^ OstDomain new evaluateInContextOnBaseLevel: aBlock! !

Array variableSubclass: #OstArray
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Misc'!

!OstArray class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/10/2012 13:41'!
fromArray: anArray
	| array index |
	array := self new: anArray size.
	index := 0.
	anArray do: [:each | array at: (index := index + 1) put: each].
	^ array! !

!CompiledMethod methodsFor: '*OmniVMNoOpt-Compiler' stamp: 'StefanMarr 3/19/2012 15:19'!
methodFlag: aBool
	"set the user-level flag bit"
	| old |
	old := self flag.
	aBool
		ifTrue: [ self objectAt: 1 put: (self header bitOr: (1 << 29)) ]
		ifFalse: [self objectAt: 1 put: (self header bitAnd: (1 << 29) bitInvert) ].
	
	^ old! !

!CompiledMethod methodsFor: '*OmniVMNoOpt-Compiler' stamp: 'StefanMarr 7/19/2012 22:49'!
properties: aMethodProperties
	"Set the method-properties of the receiver to aMethodProperties."
	self literalAt: self numLiterals - 1
		put: (aMethodProperties isEmpty
				ifTrue: [aMethodProperties selector]
				ifFalse: [aMethodProperties
							setMethod: self;
							yourself]).
	
	"After setting the properties we need to reconsider the flag"
	(self pragmaAt: #omniUnenforced) ifNotNilDo: [:p | self methodFlag: true]. "For OmniST support"! !

!SmalltalkImage methodsFor: '*OmniVMNoOpt-special objects' stamp: 'StefanMarr 8/6/2012 17:39'!
recreateSpecialObjectsArray
	"Smalltalk recreateSpecialObjectsArray"
	
	"To external package developers:
	**** DO NOT OVERRIDE THIS METHOD.  *****
	If you are writing a plugin and need additional special object(s) for your own use, 
	use addGCRoot() function and use own, separate special objects registry "
	
	"The Special Objects Array is an array of objects used by the Squeak virtual machine.
	 Its contents are critical and accesses to it by the VM are unchecked, so don't even
	 think of playing here unless you know what you are doing."
	| newArray |
	newArray := Array new: 100.
	"Nil false and true get used throughout the interpreter"
	newArray at: 1 put: nil.
	newArray at: 2 put: false.
	newArray at: 3 put: true.
	"This association holds the active process (a ProcessScheduler)"
	newArray at: 4 put: (self globals associationAt: #Processor).
	"Numerous classes below used for type checking and instantiation"
	newArray at: 5 put: Bitmap.
	newArray at: 6 put: SmallInteger.
	newArray at: 7 put: ByteString.
	newArray at: 8 put: Array.
	newArray at: 9 put: Smalltalk.
	newArray at: 10 put: Float.
	newArray at: 11 put: MethodContext.
	newArray at: 12 put: BlockContext.
	newArray at: 13 put: Point.
	newArray at: 14 put: LargePositiveInteger.
	newArray at: 15 put: Display.
	newArray at: 16 put: Message.
	newArray at: 17 put: CompiledMethod.
	newArray at: 18 put: (self specialObjectsArray at: 18).
	"(low space Semaphore)"
	newArray at: 19 put: Semaphore.
	newArray at: 20 put: Character.
	newArray at: 21 put: #doesNotUnderstand:.
	newArray at: 22 put: #cannotReturn:.
	newArray at: 23 put: nil. "This is the process signalling low space."
	"An array of the 32 selectors that are compiled as special bytecodes,
	 paired alternately with the number of arguments each takes."
	newArray at: 24 put: #(	#+ 1 #- 1 #< 1 #> 1 #<= 1 #>= 1 #= 1 #~= 1
							#* 1 #/ 1 #\\ 1 #@ 1 #bitShift: 1 #// 1 #bitAnd: 1 #bitOr: 1
							#at: 1 #at:put: 2 #size 0 #next 0 #nextPut: 1 #atEnd 0 #== 1 #class 0
							#blockCopy: 1 #value 0 #value: 1 #do: 1 #new 0 #new: 1 #x 0 #y 0 ).
	"An array of the 255 Characters in ascii order.
	 Cog inlines table into machine code at: prim so do not regenerate it."
	newArray at: 25 put: (self specialObjectsArray at: 25).
	newArray at: 26 put: #mustBeBoolean.
	newArray at: 27 put: ByteArray.
	newArray at: 28 put: Process.
	"An array of up to 31 classes whose instances will have compact headers"
	newArray at: 29 put: self compactClassesArray.
	newArray at: 30 put: (self specialObjectsArray at: 30).
	"(delay Semaphore)"
	newArray at: 31 put: (self specialObjectsArray at: 31).
	"(user interrupt Semaphore)"
	"Prototype instances that can be copied for fast initialization"
	newArray at: 32 put: (Float new: 2).
	newArray at: 33 put: (LargePositiveInteger new: 4).
	newArray at: 34 put: 0@0.
	newArray at: 35 put: #cannotInterpret:.
	"Note: This must be fixed once we start using context prototypes (yeah, right)"
	"(MethodContext new: CompiledMethod fullFrameSize)."
	newArray at: 36 put: (self specialObjectsArray at: 36). "Is the prototype MethodContext (unused by the VM)"
	newArray at: 37 put: BlockClosure.
	"(BlockContext new: CompiledMethod fullFrameSize)."
	newArray at: 38 put: (self specialObjectsArray at: 38). "Is the prototype BlockContext (unused by the VM)"
	"array of objects referred to by external code"
	newArray at: 39 put: (self specialObjectsArray at: 39).	"preserve external semaphores"
	newArray at: 40 put: nil. "Reserved for Mutex in Cog VMs"
	newArray at: 41 put: nil. "Reserved for a LinkedList instance for overlapped calls in CogMT"
	"finalization Semaphore"
	newArray at: 42 put: ((self specialObjectsArray at: 42) ifNil: [Semaphore new]).
	newArray at: 43 put: LargeNegativeInteger.
	"External objects for callout.
	 Note: Written so that one can actually completely remove the FFI."
	newArray at: 44 put: (self at: #ExternalAddress ifAbsent: []).
	newArray at: 45 put: (self at: #ExternalStructure ifAbsent: []).
	newArray at: 46 put: (self at: #ExternalData ifAbsent: []).
	newArray at: 47 put: (self at: #ExternalFunction ifAbsent: []).
	newArray at: 48 put: (self at: #ExternalLibrary ifAbsent: []).
	newArray at: 49 put: #aboutToReturn:through:.
	newArray at: 50 put: #run:with:in:.
	"51 reserved for immutability message"
	"newArray at: 51 put: #attemptToAssign:withIndex:."
	newArray at: 52 put: #(nil "nil => generic error" #'bad receiver'
							#'bad argument' #'bad index'
							#'bad number of arguments'
							#'inappropriate operation'  #'unsupported operation'
							#'no modification' #'insufficient object memory'
							#'insufficient C memory' #'not found' #'bad method'
							#'internal error in named primitive machinery'
							#'object may move').
	"53 to 55 are for Alien"
	newArray at: 53 put: (self at: #Alien ifAbsent: []).
	newArray at: 54 put: #invokeCallback:stack:registers:jmpbuf:.
	newArray at: 55 put: (self at: #UnsafeAlien ifAbsent: []).

	"Weak reference finalization"
	newArray at: 56 put: (self at: #WeakFinalizationList ifAbsent: []).

		"Omni Changes"
	newArray at: 61 put: #readField:of:.
	newArray at: 62 put: #requestExecutionOf:on:.
	newArray at: 63 put: #write:toField:of:.
	
	newArray at: 70 put: OstDomain.
	newArray at: 71 put: ONOMirror OstDomainSelectorArray.

	"Now replace the interpreter's reference in one atomic operation"
	self specialObjectsArray become: newArray! !

!SharedQueue methodsFor: '*OmniVMNoOpt-Core' stamp: 'StefanMarr 3/22/2012 15:20'!
peekWaiting
	^monitor critical: [
		monitor waitWhile: [ items isEmpty ].
		items first ]! !

Object subclass: #ONOCompilerSupport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection'!

!ONOCompilerSupport commentStamp: 'StefanMarr 7/29/2012 16:55' prior: 0!
ONOCompilerSupport is a helper class to make sure that methods with our pragmas are recompiled after the relevent changes (to CompiledMethod) have been done.!

!ONOCompilerSupport class methodsFor: 'initialization' stamp: 'StefanMarr 7/29/2012 17:15'!
initialize
	self resetMethodFlagForOmniUnenforced.
	[ self recompileClassWithOmniUnenforced. ] "REM: disabled, the other one works. This one does not really. The compiler does not seem to set the properties when recompiling."! !

!ONOCompilerSupport class methodsFor: 'ensure consistency' stamp: 'StefanMarr 7/29/2012 17:13'!
recompileClassWithOmniUnenforced
	| classesWithInconsistentMethods withOmniUnenforced |
	"REM: this does not really work. Use #resetMethodFlagForOmniUnenforced instead."
	withOmniUnenforced := CompiledMethod allInstances 
			select: [:m | (m pragmaAt: #omniUnenforced) notNil].
	
	classesWithInconsistentMethods := withOmniUnenforced collect: [:m | m methodClass ] as: Set.
	classesWithInconsistentMethods do: [:c | c compileAll].
	! !

!ONOCompilerSupport class methodsFor: 'ensure consistency' stamp: 'StefanMarr 7/29/2012 17:14'!
resetMethodFlagForOmniUnenforced
	| classesWithInconsistentMethods withOmniUnenforced |
	"REM: this does not really work. Use #resetMethodFlagForOmniUnenforced instead."
	withOmniUnenforced := CompiledMethod allInstances 
			select: [:m | (m pragmaAt: #omniUnenforced) notNil].
	
	withOmniUnenforced do: [:m | m methodFlag: true ].! !

Object subclass: #ONOMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection'!

!ONOMirror class methodsFor: 'VM support' stamp: 'StefanMarr 7/29/2012 23:09'!
OstDomainSelectorArray
	^	(OstDomain allMethodsInCategory: 'omni primitive handlers'),
		(OstDomain allMethodsInCategory: 'omni handlers')! !

!ONOMirror class methodsFor: 'VM support' stamp: 'StefanMarr 8/5/2012 20:51'!
OstDomainSelectorIndicesCppClass
	"This method generates the Cpp class we use to access the method symbols
		
		ONOMirror OstDomainSelectorIndicesCppClass.
	"
	| cpp selectors reqExecBits writeToFieldBits writeLiteralBits cppWithHash |
	
	"Make sure that the system dictionary is up to date"
	Smalltalk recreateSpecialObjectsArray.
	
	reqExecBits := 0.
	writeToFieldBits := 0.
	writeLiteralBits := 0.
	cpp := 'class OstDomainSelector_Indices {
public:
'.
	selectors := self OstDomainSelectorArray.
	
	selectors doWithIndex: [:sel :i |
		cpp := cpp, '  static const oop_int_t ', ((self SymbolForCpp: sel) padded: #right to: 60 with: $ ), ' = ', (i - 1) asString, ';
'.											
		"REM: we do it after i+1, because we need 1-based indices for bitAt:"
		(sel beginsWith: #requestExecution)
			ifTrue: [	reqExecBits := reqExecBits bitAt: i put: 1. ].
		(sel beginsWith: #write:toField:)
			ifTrue: [writeToFieldBits := writeToFieldBits bitAt: i put: 1].
		(sel beginsWith: #write:toLiteral:)
			ifTrue: [writeLiteralBits := writeLiteralBits bitAt: i put: 1].
	].
	
	cpp := cpp, '


'.
	
	"A second pass to generate masks"			
	selectors doWithIndex: [:sel :i |
		cpp := cpp, '  static const oop_int_t ', (((self SymbolForCpp: sel), '_Mask') padded: #right to: 60 with: $ ), ' = 0x', (0 bitAt: i put: 1) printStringHex, ' << Tag_Size;
'.
	].

				
	cpp := cpp, '

  /** Make it easier to identify whether any of them is customize.
       Remember that it''s a SmallInt and we need to shift by the Tag_Bit */
  static const oop_int_t RequestExecutionMask = 0x', (reqExecBits printStringHex),' << Tag_Size;
  static const oop_int_t WriteToFieldMask     = 0x', (writeToFieldBits printStringHex),' << Tag_Size;
  static const oop_int_t WriteToLiteralMask   = 0x', (writeLiteralBits printStringHex),' << Tag_Size;
'.

	cpp := cpp, '
};

'.
	
	cppWithHash := '/// WARNING: Generated code
/// This class can be generated by ONOMirror >> #OstDomainSelectorIndicesCppClass 
///
/// Do not modifiy manually, needs to be in sync with the image

',	cpp, '

/** Identity Hash: ', (MD5 new hashStream: cpp asByteArray readStream) hex asUppercase, '  **/

'.
	^ cppWithHash! !

!ONOMirror class methodsFor: 'VM support' stamp: 'StefanMarr 3/13/2012 15:49'!
SymbolForCpp: aSymbol
	| capitalizeNext |
	capitalizeNext := true.
	^ aSymbol collect: [:c |
		c = $:
			ifTrue: [ capitalizeNext := true. $_ ]
			ifFalse: [
				capitalizeNext
					ifTrue: [ capitalizeNext := false. c asUppercase ]
					ifFalse: [c]
			]
	].! !

!ONOMirror class methodsFor: 'encoding domain customizations' stamp: 'StefanMarr 7/20/2012 23:15'!
checkConsistencyForAllDomains
	"self checkConsistencyForAllDomains"
	OstDomain allSubclassesDo: [:c |
		self checkConsistencyOfDomain: c.
	].! !

!ONOMirror class methodsFor: 'encoding domain customizations' stamp: 'StefanMarr 8/5/2012 20:52'!
checkConsistencyOfDomain: aDomainClass
	"Do a simple check whether the definition seems to be proper."
	
	| selectors definedSelectors |
	(aDomainClass inheritsFrom: OstDomain)
		ifFalse: [Error signal: 'Not strictly necessary, but a convenient constraint for the moment.'].
	
	selectors := self OstDomainSelectorArray.
	
	definedSelectors := aDomainClass methodDict keys.
	
	"Check for both #write:toField:of:"
	(definedSelectors includes: #write:toField:of:) = (definedSelectors includes: #write:toField:of:return:)
		ifFalse: [Warning signal:  aDomainClass printString, ' contains only one of the #write:toField: handlers, but requires both.'].
		
	"Check for both #write:toLiteral:"
	(definedSelectors includes: #write:toLiteral:) = (definedSelectors includes: #write:toLiteral:return:)
		ifFalse: [Warning signal:  aDomainClass printString, ' contains only one of the #write:toLiteral: handlers, but requires both.'].

	
	"Check for #requestExec."
	(definedSelectors contains: [:sel | sel beginsWith: #requestExecution])
		ifTrue: [
			| reqExecSels missing |
			reqExecSels := selectors select: [:sel | sel beginsWith: #requestExecution ].
			missing := OrderedCollection new.
			
			reqExecSels do: [:sel | 
				(definedSelectors includes: sel) 
					ifFalse: [missing add: sel]].
			
			missing size > 0 ifTrue: [
				Warning signal: aDomainClass printString,
				' does only redefine part of the #requestExec* methods. The following are missing: ',
				(missing fold: [:a :b | a, ' ', b]).
			]
		]! !

!ONOMirror class methodsFor: 'encoding domain customizations' stamp: 'StefanMarr 7/31/2012 21:51'!
customizationConstIsConstistentFor: aClass
	| const customizableSelectors inconsistencies |
	inconsistencies := OrderedCollection new.
	customizableSelectors := self OstDomainSelectorArray.
	const := aClass domainCustomizations.
	
	customizableSelectors do: [:sel |
		| selEncoded |
		selEncoded := (const bitAt: (self encodingBitFor: sel)) = 1.
		(selEncoded = (self domain: aClass customizesSelector: sel))
			ifFalse: [ inconsistencies add: sel ]].
	
	^ inconsistencies size = 0! !

!ONOMirror class methodsFor: 'encoding domain customizations' stamp: 'StefanMarr 4/23/2012 15:43'!
domain: aDomainClass customizesSelector: aSel
	(aDomainClass includesSelector: aSel)
		ifTrue: [^ true.].
		
	aDomainClass superclass == OstDomain ifFalse: [
		^ self domain: aDomainClass superclass customizesSelector: aSel].
	
	^ false! !

!ONOMirror class methodsFor: 'primitives' stamp: 'StefanMarr 3/10/2012 18:31'!
domainOf: anObject
	"Returns the domain object on success"
	<primitive: 'primitiveGetDomain' module: 'OmniPlugin'>
	^ -1! !

!ONOMirror class methodsFor: 'encoding domain customizations' stamp: 'StefanMarr 7/29/2012 18:28'!
encodedCustomizations: anIntWithEncodingBits
	| customizableSelectors custom |
	custom := OrderedCollection new.
	customizableSelectors := self OstDomainSelectorArray.
	
	1 to: customizableSelectors size do: [:i |
		| sel |
		sel := customizableSelectors at: i.
		((anIntWithEncodingBits bitAt: i) = 1)
			ifTrue: [ custom add: sel ]].
	
	^ custom! !

!ONOMirror class methodsFor: 'encoding domain customizations' stamp: 'StefanMarr 7/31/2012 21:44'!
encodingBitFor: selector
	| sels |
	sels := self OstDomainSelectorArray.
	^ sels indexOf: selector.! !

!ONOMirror class methodsFor: 'encoding domain customizations' stamp: 'StefanMarr 7/31/2012 21:52'!
encodingFor: aDomainClass
	| selectors encoding |
	
	(aDomainClass includesBehavior: OstDomain)
		ifFalse: [Error signal: 'Not strictly necessary, but a convenient constraint for the moment.'].
	
	selectors := self OstDomainSelectorArray.
	
	encoding := 0.
	
	selectors do: [:sel |
		(self domain: aDomainClass customizesSelector: sel)
			ifTrue: [
				encoding := encoding	bitAt: (self encodingBitFor: sel)
										put: 1]].
	
	^ encoding! !

!ONOMirror class methodsFor: 'primitives' stamp: 'StefanMarr 7/19/2012 22:54'!
evaluate: block onBaseLevel: domain
	<omniUnenforced>
	<primitive: 'primitiveEvaluateOnBaseLevel' module: 'OmniPlugin'>
	^ block value! !

!ONOMirror class methodsFor: 'primitives' stamp: 'StefanMarr 7/19/2012 22:55'!
executesOnBaseLevel
	<omniUnenforced>
	<primitive: 'primitiveExecutesOnBaseLevel' module: 'OmniPlugin'>
	^ nil! !

!ONOMirror class methodsFor: 'primitives' stamp: 'StefanMarr 7/19/2012 22:55'!
executesOnMetaLevel
	<omniUnenforced>
	<primitive: 'primitiveExecutesOnMetaLevel' module: 'OmniPlugin'>
	^ nil! !

!ONOMirror class methodsFor: 'initialization' stamp: 'StefanMarr 8/6/2012 17:50'!
initialize
	| workspace |
	"All the things that need to be done to make sure that the VM and Image are in sync,
	 most notably to make sure that the in-image sync problems are solved."
	self updateDomainCustomizationsForAllDomains.
	
	"Make sure special objects array is in sync."
	Smalltalk recreateSpecialObjectsArray.
	
	"Make sure all the method flags are set correctly"
	ONOCompilerSupport initialize.
	
	workspace := Workspace open.
	workspace
		toggleStylingActive;
		label: 'OmniVM: ostdomain_selector_indicies.h';
		contents: self OstDomainSelectorIndicesCppClass.! !

!ONOMirror class methodsFor: 'primitives' stamp: 'StefanMarr 7/29/2012 00:13'!
reenableScheduling
	<primitive: 'primitiveReenableScheduling' module: 'OmniPlugin'>
	^ false! !

!ONOMirror class methodsFor: 'primitives' stamp: 'StefanMarr 3/10/2012 18:28'!
setDomainOf: anObject to: aDomain
	"Returns self on success"
	<primitive: 'primitiveSetDomain' module: 'OmniPlugin'>
	^ nil! !

!ONOMirror class methodsFor: 'primitives' stamp: 'StefanMarr 7/19/2012 22:54'!
switchToBaseLevel
	<omniUnenforced>
	<primitive: 'primitiveSwitchToBaseLevel' module: 'OmniPlugin'>
	^ nil! !

!ONOMirror class methodsFor: 'primitives' stamp: 'StefanMarr 7/19/2012 22:54'!
switchToMetaLevel
	<omniUnenforced>
	<primitive: 'primitiveSwitchToMetaLevel' module: 'OmniPlugin'>
	^ nil! !

!ONOMirror class methodsFor: 'encoding domain customizations' stamp: 'StefanMarr 7/30/2012 11:14'!
updateDomainCustomizationsForAllDomains
	"self updateDomainCustomizationsForAllDomains"
	OstDomain withAllSubclassesDo: [:c |
		| encoding |
		encoding := self encodingFor: c.
		
		((c respondsTo: #domainCustomizations) and: [c domainCustomizations ~= encoding])
		 	ifTrue: [ c class compile: ('domainCustomizations ^ ', encoding hex) classified: 'VM support' ].
	].! !

ONOMirror subclass: #OstMirror
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection'!

Object subclass: #ONOTestObject
	instanceVariableNames: 'a b'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection-Tests'!

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/10/2011 23:45'!
a
	^ a! !

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/10/2011 23:45'!
a: anObj
	a := anObj! !

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/11/2011 21:22'!
ab
	^ a, b! !

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/10/2011 23:46'!
b
	^ b! !

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/10/2011 23:48'!
b: anObj
	b := anObj! !

!ONOTestObject methodsFor: 'initialize-release' stamp: 'StefanMarr 4/22/2012 17:46'!
initialize
	a := #a.
	b := #b.! !

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/10/2011 23:49'!
magicNil
	^ nil! !

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/10/2011 23:49'!
magicOne
	^ 1! !

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/10/2011 23:49'!
magicSelf
	^ self! !

!ONOTestObject methodsFor: 'test helper' stamp: 'StefanMarr 11/10/2011 23:49'!
makeOne
	b := 1.! !

ONOTestObject subclass: #ONOTestObjectSub
	instanceVariableNames: 'c collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection-Tests'!

!ONOTestObjectSub methodsFor: 'test helper' stamp: 'StefanMarr 3/21/2012 15:37'!
a
	^ super a! !

!ONOTestObjectSub methodsFor: 'test helper' stamp: 'StefanMarr 4/1/2012 14:24'!
c
	^ c! !

!ONOTestObjectSub methodsFor: 'test helper' stamp: 'StefanMarr 4/1/2012 21:53'!
collection
	^ collection! !

!ONOTestObjectSub methodsFor: 'testTimesRepeat' stamp: 'StefanMarr 4/1/2012 21:53'!
incC: n
	c := c + n.
	collection at: c put: ONOMirror executesOnBaseLevel.! !

!ONOTestObjectSub methodsFor: 'testSpecialSendBytecode' stamp: 'StefanMarr 4/1/2012 14:01'!
initForTestSpecialSendBytecode
	a := 0.
	b := 0.
	c := 0.
	collection := OrderedCollection new.
	collection add: #first.! !

!ONOTestObjectSub methodsFor: 'testTimesRepeat' stamp: 'StefanMarr 4/1/2012 21:52'!
initForTimesRepeat
	c := 0.
	collection := Array new: 4.! !

!ONOTestObjectSub methodsFor: 'testSpecialSendBytecode' stamp: 'StefanMarr 4/1/2012 17:26'!
next
	"For the test necessary of missbehavior of BGRepeatStream>>#next"

	^collection at: (a := a + 1)! !

!ONOTestObjectSub methodsFor: 'testTimesRepeat' stamp: 'StefanMarr 4/1/2012 20:23'!
repeat: n on: o
	n timesRepeat: [o incC: 1]! !

Object subclass: #OPromise
	instanceVariableNames: 'signal value'
	classVariableNames: 'NoValueDelivered'
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Misc'!

!OPromise commentStamp: 'StefanMarr 3/9/2012 21:09' prior: 0!
Provides a simple promise implementation.
A promise is a value that is going to be resolved in the future, typically by an asynchronous computation.
Reading an unresolved promise is a blocking operation.!

!OPromise class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/6/2011 00:19'!
example
	"This is not a real test case, but just to see how it is supposed to work"
	| p |
	p := OPromise new.
	
	[|val| 
	 Transcript log: 'About to read promised value.'.
	 val := p read.
	 Transcript log: 'Val: ', val asString.] fork.

	Processor yield.
	
	Transcript log: 'About to deliver promised value.'.
	p deliver: 42.
	Transcript log: 'Deliver promised value.'.
	! !

!OPromise class methodsFor: 'initialization' stamp: 'StefanMarr 11/4/2011 15:53'!
initialize
	NoValueDelivered := Object new.! !

!OPromise methodsFor: 'promise' stamp: 'StefanMarr 7/19/2012 22:53'!
await
	<omniUnenforced>
	[value = NoValueDelivered] whileTrue: [
		"This is ugly, but I do not see how I can prevent the data
		 race for signals otherwise.
		 In case there are multiple possible consumers everyone
		 but the first will starve when they arrive before the
		 promise was delivered.
		 Now, we just have a delay, but it is guaranteed to return."
		"signal waitTimeoutMSecs: 100. only available in Pharo"
		(Delay new setDelay:100 forSemaphore: signal) wait.
	].! !

!OPromise methodsFor: 'promise' stamp: 'StefanMarr 7/19/2012 22:53'!
deliver: aValue
	<omniUnenforced>
	"Deliver the promised value."
	
	
	"Warning: this is racy, but we don't care for the moment.
	 Should be a single produce anyway. Everything else is a bug.
	 And, we do at least best effort error notification..."
	value = NoValueDelivered ifFalse: [
		| err |
		err := Error new.
		err messageText: 'Promise has been delivered more than once.'.
		err signal.
	].

	value := aValue.
	
	signal signal.
	
	^ value.! !

!OPromise methodsFor: 'initialization' stamp: 'StefanMarr 11/4/2011 16:09'!
initialize
	value := NoValueDelivered.
	signal := Semaphore new.! !

!OPromise methodsFor: 'accessing' stamp: 'StefanMarr 7/19/2012 22:59'!
read
	<omniUnenforced>
	self await.
	^ value! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/14/2012 15:13'!
baselevelPerform: aSymbol 
	"Send the unary selector, aSymbol, to the receiver.
	Fail if the number of arguments expected by the selector is not zero.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol withArguments: (Array new: 0)! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/14/2012 15:13'!
baselevelPerform: selector orSendTo: otherTarget
	"If I wish to intercept and handle selector myself, do it; else send it to otherTarget"
	^ otherTarget baselevelPerform: selector! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/14/2012 15:14'!
baselevelPerform: aSymbol with: anObject 
	"Send the selector, aSymbol, to the receiver with anObject as its argument.
	Fail if the number of arguments expected by the selector is not one.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol withArguments: (Array with: anObject)! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/14/2012 15:20'!
baselevelPerform: aSymbol with: firstObject with: secondObject 
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not two.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol withArguments: (Array with: firstObject with: secondObject)! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/14/2012 15:20'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject 
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol
		withArguments: (Array with: firstObject with: secondObject with: thirdObject)! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/17/2012 12:30'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: p4
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol
		withArguments: (Array with: firstObject with: secondObject with: thirdObject with: p4)! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/31/2012 14:20'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: p4 with: p5
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. p4. p5}! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/31/2012 14:20'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: p4 with: p5 with: p6
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. p4. p5. p6}! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/31/2012 14:20'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: p4 with: p5 with: p6 with: p7
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. p4. p5. p6. p7}! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/31/2012 14:20'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: p4 with: p5 with: p6 with: p7 with: p8
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. p4. p5. p6. p7. p8}! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/31/2012 14:20'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. p4. p5. p6. p7. p8. p9}! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/31/2012 14:19'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. p4. p5. p6. p7. p8. p9. p10}! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/31/2012 14:19'!
baselevelPerform: aSymbol with: firstObject with: secondObject with: thirdObject with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10 with: p11
	"Send the selector, aSymbol, to the receiver with the given arguments.
	Fail if the number of arguments expected by the selector is not three.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 185>
	^ self baselevelPerform: aSymbol
		withArguments: {firstObject. secondObject. thirdObject. p4. p5. p6. p7. p8. p9. p10. p11}! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/14/2012 15:34'!
baselevelPerform: selector withArguments: argArray 
	"Send the selector, aSymbol, to the receiver with arguments in argArray.
	Fail if the number of arguments expected by the selector 
	does not match the size of argArray.
	Primitive. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 186>
	^ self baselevelPerform: selector withArguments: argArray inSuperclass: self class! !

!Object methodsFor: '*OmniVMNoOpt-message handling' stamp: 'StefanMarr 3/14/2012 15:35'!
baselevelPerform: selector withArguments: argArray inSuperclass: lookupClass
	"NOTE:  This is just like perform:withArguments:, except that
	the message lookup process begins, not with the receivers's class,
	but with the supplied superclass instead.  It will fail if lookupClass
	cannot be found among the receiver's superclasses.
	Primitive. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 187>
	(selector isMemberOf: Symbol)
		ifFalse: [^ self error: 'selector argument must be a Symbol'].
	(selector numArgs = argArray size)
		ifFalse: [^ self error: 'incorrect number of arguments'].
	(self class == lookupClass or: [self class inheritsFrom: lookupClass])
		ifFalse: [^ self error: 'lookupClass is not in my inheritance chain'].
	self primitiveFailed! !

!Object methodsFor: '*OmniVMNoOpt' stamp: 'StefanMarr 7/19/2012 22:53'!
doesNotUnderstand: aMessage
	<omniUnenforced>
	 "Handle the fact that there was an attempt to send the given message to the receiver but the receiver does not understand this message (typically sent from the machine when a message is sent to the receiver and no method is defined for that selector)."
	"Testing: (3 activeProcess)"
	"fixed suggested by Eliot miranda to make sure 
	
	[Object new blah + 1]
		on: MessageNotUnderstood
		do: [:e | e resume: 1] does not loop indefinitively"
		
	| exception resumeValue |
	(exception := MessageNotUnderstood new)
		message: aMessage;
		receiver: self.
	resumeValue := exception signal.
	^exception reachedDefaultHandler
		ifTrue: [aMessage sentTo: self]
		ifFalse: [resumeValue]! !

Object subclass: #OmniNoOptTransporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Transporter'!

!OmniNoOptTransporter class methodsFor: 'transporter' stamp: 'StefanMarr 11/10/2011 16:38'!
transportersForFileOutMenu
	^ { Transporter forPackage: (PackageInfo named: 'OmniVMNoOpt') }! !

Object subclass: #OstDomain
	instanceVariableNames: 'domainForNewObjects domainCustomizations'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection'!

!OstDomain commentStamp: 'StefanMarr 4/22/2012 21:58' prior: 0!
OstDomain is the root class for all Omni Domain definitions.

Instance Variables:
	domainForNewObjects	<OstDomain> - it is a cache for the #domainForNewObjects message,
											which is initialized on creation of the domain object.
											It is an optimization for the VM, to not need to execute the method
											which would have been a lot harder to implement correctly.
	
	domainCustomizations	<SmallInteger> - encoding which omni handlers have been customized in the domain.
											This allows avoiding unnecessary overhead in the VM.
											The encoding is defined corresponding to the index of the selectors in
											the ONOMirror >> #OstDomainSelectorArray.!

OstDomain subclass: #HaltDomain
	instanceVariableNames: ''
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection'!

!HaltDomain class methodsFor: 'defaults' stamp: 'StefanMarr 8/3/2012 22:59'!
default
	Default ifNil: [Default := self new].
	^ Default! !

!HaltDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 8/3/2012 22:47'!
primAt: idx on: anObj
	<omniUnenforced>
	Halt signal.
	^ anObj at: idx! !

!HaltDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 8/3/2012 22:47'!
primAt: idx on: anObj put: aVal
	<omniUnenforced>
	Halt signal.
	^ anObj at: idx put: aVal! !

!HaltDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 8/3/2012 22:47'!
primBasicAt: idx on: anObj
	<omniUnenforced>
	Halt signal.
	^ anObj basicAt: idx! !

!HaltDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 8/3/2012 22:47'!
primBasicAt: idx on: anObj put: aVal
	<omniUnenforced>
	Halt signal.
	^ anObj basicAt: idx put: aVal! !

!HaltDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 8/3/2012 22:47'!
primInstVarAt: idx on: anObj
	<omniUnenforced>
	Halt signal.
	^ anObj instVarAt: idx! !

!HaltDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 8/3/2012 22:47'!
primInstVarAt: idx on: anObj put: aVal
	<omniUnenforced>
	Halt signal.
	^ anObj instVarAt: idx put: aVal! !

!HaltDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 8/3/2012 22:47'!
primNext: obj
	<omniUnenforced>
	Halt signal.
	^ obj next! !

!HaltDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 8/3/2012 22:47'!
primNext: obj put: val
	<omniUnenforced>
	Halt signal.
	^ obj nextPut: val! !

!HaltDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 8/3/2012 22:47'!
primReplaceFrom: start to: stop with: replacement startingAt: repStart on: obj
	<omniUnenforced>
	Halt signal.
	^ obj replaceFrom: start to: stop with: replacement startingAt: repStart! !

!HaltDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 8/3/2012 22:47'!
primShallowCopy: anObj
	<omniUnenforced>
	Halt signal.
	^ anObj shallowCopy! !

!HaltDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/3/2012 22:47'!
readField: idx of: obj
	<omniUnenforced>
	Halt signal.
	^ obj instVarAt: idx! !

!HaltDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/3/2012 22:48'!
readLiteral: literal
	<omniUnenforced>
	Halt signal.
	^ literal value! !

!HaltDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/3/2012 22:48'!
requestExecution: p1 of: aSelector on: anObject
	<omniUnenforced>
	Halt signal.
	^ anObject baselevelPerform: aSelector with: p1! !

!HaltDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/3/2012 22:48'!
requestExecution: p1 with: p2 of: aSelector on: anObject
	<omniUnenforced>
	Halt signal.
	^ anObject baselevelPerform: aSelector with: p1 with: p2! !

!HaltDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/3/2012 22:48'!
requestExecution: p1 with: p2 with: p3 of: aSelector on: anObject
	<omniUnenforced>
	Halt signal.
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3! !

!HaltDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/3/2012 22:48'!
requestExecution: p1 with: p2 with: p3 with: p4 of: aSelector on: anObject
	<omniUnenforced>
	Halt signal.
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4! !

!HaltDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/3/2012 22:48'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 of: aSelector on: anObject 
	<omniUnenforced>
	Halt signal.
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5! !

!HaltDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/3/2012 22:48'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 of: aSelector on: anObject 
	<omniUnenforced>
	Halt signal.
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6! !

!HaltDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/3/2012 22:48'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 of: aSelector on: anObject
	<omniUnenforced>
	Halt signal.
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7! !

!HaltDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/3/2012 22:48'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8  of: aSelector on: anObject 
	<omniUnenforced>
	Halt signal.
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8! !

!HaltDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/3/2012 22:48'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9  of: aSelector on: anObject 
	<omniUnenforced>
	Halt signal.
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9! !

!HaltDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/3/2012 22:48'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10 of: aSelector on: anObject 
	<omniUnenforced>
	Halt signal.
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10! !

!HaltDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/3/2012 22:48'!
requestExecutionOf: aSelector on: anObject
	<omniUnenforced>
	Halt signal.
	^ anObject baselevelPerform: aSelector! !

!HaltDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/3/2012 22:48'!
requestExecutionOf: aSelector with: argArray lookup: cls on: anObject
	<omniUnenforced>
	Halt signal.
	^ anObject baselevelPerform: aSelector withArguments: argArray inSuperclass: cls.! !

!HaltDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/3/2012 22:48'!
write: val toField: idx of: obj
	<omniUnenforced>
	Halt signal.
	"The calling convention is to return val,
	 i.e., the value stored into the object field."
	obj instVarAt: idx put: val.
	^ val! !

!HaltDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/3/2012 22:48'!
write: val toField: idx of: obj return: returnValue
	<omniUnenforced>
	Halt signal.
	"The calling convention is to return 'val,
	 i.e., the value stored into the object field.'returnValue',
	 always!! This is to support the variations of the
	 store-to-object-field bytecodes in the OmniVM."
	obj instVarAt: idx put: val.
	^ returnValue! !

!HaltDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/3/2012 22:48'!
write: val toLiteral: literal
	<omniUnenforced>
	Halt signal.
	"All globals are literals, and we treat all literals equal in the VM"
	literal value: val.
	^ val! !

!HaltDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/5/2012 20:53'!
write: val toLiteral: literal return: returnValue
	<omniUnenforced>
	Halt signal.
	"All globals are literals, and we treat all literals equal in the VM"
	literal value: val.
	^ returnValue! !

OstDomain subclass: #ONORWTestDomain
	instanceVariableNames: 'target cntReadA cntReadB cntWriteA cntWriteB lastSuperSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection-Tests'!

!ONORWTestDomain class methodsFor: 'VM support' stamp: 'StefanMarr 8/2/2012 20:53'!
domainCustomizations ^ 16r3800400! !

!ONORWTestDomain methodsFor: 'initialize-release' stamp: 'StefanMarr 3/14/2012 11:09'!
initialize
	super initialize.
	
	cntReadA := 0.
	cntReadB := 0.
	cntWriteA := 0.
	cntWriteB := 0.! !

!ONORWTestDomain methodsFor: 'accessing' stamp: 'StefanMarr 3/21/2012 15:39'!
lastSuperSelector
	^ lastSuperSelector! !

!ONORWTestDomain methodsFor: 'test helper' stamp: 'StefanMarr 3/14/2012 11:08'!
readCountA
	^ cntReadA! !

!ONORWTestDomain methodsFor: 'test helper' stamp: 'StefanMarr 3/14/2012 11:08'!
readCountB
	^ cntReadB! !

!ONORWTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 23:00'!
readField: idx of: obj
	<omniUnenforced>
	obj == target ifTrue: [
		[Transcript cr; show: 'read field: ', idx asString.].
		
		idx = 1 ifTrue: [cntReadA := cntReadA + 1.].
		idx = 2 ifTrue: [cntReadB := cntReadB + 1.].
	].
	
	^ obj instVarAt: idx! !

!ONORWTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:54'!
requestExecutionOf: aSelector with: argArray lookup: cls on: anObject
	<omniUnenforced>
	lastSuperSelector := aSelector.
	^ anObject baselevelPerform: aSelector withArguments: argArray inSuperclass: cls.! !

!ONORWTestDomain methodsFor: 'test helper' stamp: 'StefanMarr 3/14/2012 11:08'!
target: targetObj
	target := targetObj! !

!ONORWTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/2/2012 20:50'!
write: val toField: idx of: obj
	<omniUnenforced>
	obj == target ifTrue: [
		[Transcript cr; show: 'write to field: ', idx asString].
		idx = 1 ifTrue: [cntWriteA := cntWriteA + 1.].
		idx = 2 ifTrue: [cntWriteB := cntWriteB + 1.].
	].

	obj instVarAt: idx put: val.
	^ val! !

!ONORWTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/2/2012 20:50'!
write: val toField: idx of: obj return: returnVal
	<omniUnenforced>
	obj == target ifTrue: [
		idx = 1 ifTrue: [cntWriteA := cntWriteA + 1.].
		idx = 2 ifTrue: [cntWriteB := cntWriteB + 1.].
	].

	obj instVarAt: idx put: val.
	^ returnVal! !

!ONORWTestDomain methodsFor: 'test helper' stamp: 'StefanMarr 3/14/2012 11:08'!
writeCountA
	^ cntWriteA! !

!ONORWTestDomain methodsFor: 'test helper' stamp: 'StefanMarr 3/14/2012 11:08'!
writeCountB
	^ cntWriteB! !

OstDomain subclass: #ONOTestDomain
	instanceVariableNames: 'target requestedSelectors cntReadA cntReadB cntWriteA cntWriteB readLiteral writtenLiteral'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection-Tests'!

!ONOTestDomain class methodsFor: 'VM support' stamp: 'StefanMarr 8/5/2012 20:55'!
domainCustomizations ^ 16rFFFFC00! !

!ONOTestDomain methodsFor: 'initialize-release' stamp: 'StefanMarr 4/22/2012 14:07'!
initialize
	super initialize.
	
	requestedSelectors := Set new.

	cntReadA := 0.
	cntReadB := 0.
	cntWriteA := 0.
	cntWriteB := 0.

	readLiteral := OrderedCollection new.! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 11/12/2011 00:41'!
readCountA
	^ cntReadA! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 11/12/2011 00:41'!
readCountB
	^ cntReadB! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 23:00'!
readField: idx of: obj
	<omniUnenforced>
	obj == target ifTrue: [
		idx = 1 ifTrue: [cntReadA := cntReadA + 1.].
		idx = 2 ifTrue: [cntReadB := cntReadB + 1.].
	].
	
	^ obj instVarAt: idx! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 4/22/2012 12:15'!
readLiteral
	^ readLiteral! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 23:00'!
readLiteral: literal
	<omniUnenforced>
	readLiteral add: literal.
	^ literal value! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:57'!
requestExecution: p1 of: aSelector on: receiver
	<omniUnenforced>
	receiver == target ifTrue: [
		requestedSelectors add: aSelector.
	].
	^ super requestExecution: p1 of: aSelector on: receiver! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/21/2012 00:19'!
requestExecution: p1 with: p2 of: aSelector on: receiver
	<omniUnenforced>
	receiver == target ifTrue: [
		requestedSelectors add: aSelector.
	].
	^ super requestExecution: p1 with: p2 of: aSelector on: receiver! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/21/2012 00:19'!
requestExecution: p1 with: p2 with: p3 of: aSelector on: receiver
	<omniUnenforced>
	receiver == target ifTrue: [
		requestedSelectors add: aSelector.
	].
	^ super requestExecution: p1 with: p2 with: p3 of: aSelector on: receiver! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/21/2012 00:20'!
requestExecution: p1 with: p2 with: p3 with: p4 of: aSelector on: receiver
	<omniUnenforced>
	receiver == target ifTrue: [
		requestedSelectors add: aSelector.
	].
	^ super requestExecution: p1 with: p2 with: p3 with: p4 of: aSelector on: receiver! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/21/2012 00:20'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 of: aSelector on: receiver
	<omniUnenforced>
	receiver == target ifTrue: [
		requestedSelectors add: aSelector.
	].
	^ super requestExecution: p1 with: p2 with: p3 with: p4 with: p5 of: aSelector on: receiver! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/21/2012 00:20'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 of: aSelector on: receiver
	<omniUnenforced>
	receiver == target ifTrue: [
		requestedSelectors add: aSelector.
	].
	^ super requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 of: aSelector on: receiver! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/21/2012 00:20'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 of: aSelector on: receiver
	<omniUnenforced>
	receiver == target ifTrue: [
		requestedSelectors add: aSelector.
	].
	^ super requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 of: aSelector on: receiver! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/21/2012 00:20'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 of: aSelector on: receiver
	<omniUnenforced>
	receiver == target ifTrue: [
		requestedSelectors add: aSelector.
	].
	^ super requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 of: aSelector on: receiver! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/21/2012 00:20'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 of: aSelector on: receiver
	<omniUnenforced>
	receiver == target ifTrue: [
		requestedSelectors add: aSelector.
	].
	^ super requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 of: aSelector on: receiver! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/21/2012 00:21'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10 of: aSelector on: receiver
	<omniUnenforced>
	receiver == target ifTrue: [
		requestedSelectors add: aSelector.
	].
	^ super requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10 of: aSelector on: receiver! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:56'!
requestExecutionOf: aSelector on: receiver
	<omniUnenforced>
	receiver == target ifTrue: [
		requestedSelectors add: aSelector.
	].
	^ super requestExecutionOf: aSelector on: receiver! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/21/2012 00:22'!
requestExecutionOf: aSelector with: argArray lookup: cls on: receiver
	<omniUnenforced>
	receiver == target ifTrue: [
		requestedSelectors add: aSelector.
	].
	^ super requestExecutionOf: aSelector with: argArray lookup: cls on: receiver! !

!ONOTestDomain methodsFor: 'test helper' stamp: 'StefanMarr 11/11/2011 23:12'!
requestedSelectors
	^ requestedSelectors! !

!ONOTestDomain methodsFor: 'test helper' stamp: 'StefanMarr 11/11/2011 22:38'!
target: targetObj
	target := targetObj! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:54'!
write: val toField: idx of: obj
	<omniUnenforced>
	obj == target ifTrue: [
		idx = 1 ifTrue: [cntWriteA := cntWriteA + 1.].
		idx = 2 ifTrue: [cntWriteB := cntWriteB + 1.].
	].

	obj instVarAt: idx put: val.
	^ obj! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/2/2012 20:51'!
write: val toField: idx of: obj return: returnVal
	<omniUnenforced>
	obj == target ifTrue: [
		idx = 1 ifTrue: [cntWriteA := cntWriteA + 1.].
		idx = 2 ifTrue: [cntWriteB := cntWriteB + 1.].
	].

	obj instVarAt: idx put: val.
	^ returnVal! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:54'!
write: val toLiteral: literal
	<omniUnenforced>
	"All globals are literals, and we treat all literals equal in the VM"
	
	writtenLiteral := literal.
	
	literal value: val.
	^ val! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/5/2012 20:54'!
write: val toLiteral: literal return: returnValue
	<omniUnenforced>
	"All globals are literals, and we treat all literals equal in the VM"
	
	writtenLiteral := literal.
	
	literal value: val.
	^ returnValue! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 11/12/2011 00:41'!
writeCountA
	^ cntWriteA! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 11/12/2011 00:41'!
writeCountB
	^ cntWriteB! !

!ONOTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 4/22/2012 12:16'!
writtenLiteral
	^ writtenLiteral! !

OstDomain subclass: #ONOWriteTestDomain
	instanceVariableNames: 'value fieldIdx targetObj returnValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection-Tests'!

!ONOWriteTestDomain class methodsFor: 'VM support' stamp: 'StefanMarr 8/3/2012 18:30'!
domainCustomizations ^ 16r3000000! !

!ONOWriteTestDomain methodsFor: 'accessing' stamp: 'StefanMarr 8/3/2012 17:27'!
fieldIdx
	^ fieldIdx! !

!ONOWriteTestDomain methodsFor: 'initialization' stamp: 'StefanMarr 8/3/2012 18:37'!
initialize
	super initialize.
	value := #noValue.
	fieldIdx := #noIdx.
	targetObj := #noObj.
	returnValue := #noReturn.! !

!ONOWriteTestDomain methodsFor: 'accessing' stamp: 'StefanMarr 8/3/2012 17:27'!
returnValue
	^ returnValue! !

!ONOWriteTestDomain methodsFor: 'accessing' stamp: 'StefanMarr 8/3/2012 17:27'!
targetObj
	^ targetObj! !

!ONOWriteTestDomain methodsFor: 'accessing' stamp: 'StefanMarr 8/3/2012 17:26'!
value
	^ value! !

!ONOWriteTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/3/2012 17:21'!
write: val toField: idx of: obj
	<omniUnenforced>
	"The calling convention is to return val,
	 i.e., the value stored into the object field."
	value := val.
	fieldIdx := idx.
	targetObj := obj.
	
	^ val! !

!ONOWriteTestDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/3/2012 17:21'!
write: val toField: idx of: obj return: returnVal
	<omniUnenforced>
	"The calling convention is to return 'val,
	 i.e., the value stored into the object field.'returnValue',
	 always!! This is to support the variations of the
	 store-to-object-field bytecodes in the OmniVM."
	
	value := val.
	fieldIdx := idx.
	targetObj := obj.
	returnValue := returnVal.
	
	^ returnVal! !

!OstDomain class methodsFor: 'omni reflection' stamp: 'StefanMarr 7/19/2012 22:53'!
currentDomain
	<omniUnenforced>
	^ ONOMirror domainOf: thisContext! !

!OstDomain class methodsFor: 'VM support' stamp: 'StefanMarr 8/5/2012 20:55'!
domainCustomizations ^ 16rFFFFFFF! !

!OstDomain class methodsFor: 'class initialization' stamp: 'StefanMarr 8/3/2012 22:44'!
makeClassADomain: cls
	"self makeClassADomain"
	"Then copy the methods"
	ONOMirror OstDomainSelectorArray do: [:selector |
		| method |
		method := self lookupSelector: selector.
		cls
			compile: method getSourceFromFile
		      classified: #'*OmniST-Core-Reflection'
		      withStamp: method timeStamp
		      notifying: nil
		      logSource: true.
	].! !

!OstDomain class methodsFor: 'class initialization' stamp: 'StefanMarr 8/3/2012 22:40'!
makeNilADomain
	"self makeNilADomain"
	"Then copy the methods"
	((self organization listAtCategoryNamed: 'omni handlers')
	 union: (self organization listAtCategoryNamed: 'omni primitive handlers'))
	 do: [:selector |
		| method |
		method := self lookupSelector: selector.
		UndefinedObject
			compile: method getSourceFromFile
		      classified: #'*OmniST-Core-Reflection'
		      withStamp: method timeStamp
		      notifying: nil
		      logSource: true.
	].! !

!OstDomain class methodsFor: 'omni reflection' stamp: 'StefanMarr 3/10/2012 18:32'!
omniDomainFrom: obj
	^ ONOMirror domainOf: obj! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 3/10/2012 18:33'!
adoptObject: obj
	ONOMirror setDomainOf: obj to: self.
	^ obj! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 12/8/2011 14:06'!
domainForNewObjects
	"#basicNew need to determine which domain a new object is supposed
	 to belong to.
	 The standard domain is self, the domain of the currently executing
	 OProcess.
	
	 If this method is overriden, make sure that you do not allocate any objects here!!!!!!"
	^ self! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 3/13/2012 12:40'!
evaluateInContext: aBlock
	| oldDomain result |
	oldDomain := ONOMirror domainOf: thisContext.
	
	ONOMirror setDomainOf: thisContext to: self.
	
	result := aBlock value.
	
	ONOMirror setDomainOf: thisContext to: oldDomain.
	
	^ result! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 7/19/2012 22:54'!
evaluateInContextOnBaseLevel: aBlock
	<omniUnenforced>
	^ ONOMirror evaluate: aBlock onBaseLevel: self! !

!OstDomain methodsFor: 'initialize-release' stamp: 'StefanMarr 4/23/2012 15:45'!
initialize
	super initialize.
	domainForNewObjects := self domainForNewObjects.
	domainCustomizations := self class domainCustomizations. "ONOMirror encodingFor: self class"! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 3/20/2012 16:18'!
newProcessFor: aBlock
	"Answer a Process running the code in aBlock in this domain.
	 The process is not scheduled."
	| ctx proc |
	<primitive: 19> "Simulation guard"
	ctx := [aBlock value.
			Processor terminateActive] asContext.
	proc := Process
		forContext: ctx
		priority: Processor activePriority.

	ONOMirror setDomainOf: ctx to: self.
	ONOMirror setDomainOf: proc to: self.
	^ proc.! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 7/19/2012 22:59'!
primAt: idx on: anObj
	<omniUnenforced>
	^ anObj at: idx! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 7/19/2012 22:59'!
primAt: idx on: anObj put: aVal
	<omniUnenforced>
	^ anObj at: idx put: aVal! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 7/19/2012 22:59'!
primBasicAt: idx on: anObj
	<omniUnenforced>
	^ anObj basicAt: idx! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 7/19/2012 22:59'!
primBasicAt: idx on: anObj put: aVal
	<omniUnenforced>
	^ anObj basicAt: idx put: aVal! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 7/19/2012 22:59'!
primInstVarAt: idx on: anObj
	<omniUnenforced>
	^ anObj instVarAt: idx! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 7/19/2012 22:59'!
primInstVarAt: idx on: anObj put: aVal
	<omniUnenforced>
	^ anObj instVarAt: idx put: aVal! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 7/29/2012 23:02'!
primNext: obj
	<omniUnenforced>
	^ obj next! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 7/29/2012 23:02'!
primNext: obj put: val
	<omniUnenforced>
	^ obj nextPut: val! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 7/29/2012 23:02'!
primReplaceFrom: start to: stop with: replacement startingAt: repStart on: obj
	<omniUnenforced>
	^ obj replaceFrom: start to: stop with: replacement startingAt: repStart! !

!OstDomain methodsFor: 'omni primitive handlers' stamp: 'StefanMarr 7/19/2012 22:59'!
primShallowCopy: anObj
	<omniUnenforced>
	^ anObj shallowCopy! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 23:00'!
readField: idx of: obj
	<omniUnenforced>
	^ obj instVarAt: idx! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 23:00'!
readLiteral: literal
	<omniUnenforced>
	^ literal value! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 23:00'!
requestExecution: p1 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject baselevelPerform: aSelector with: p1! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:57'!
requestExecution: p1 with: p2 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject baselevelPerform: aSelector with: p1 with: p2! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:57'!
requestExecution: p1 with: p2 with: p3 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:56'!
requestExecution: p1 with: p2 with: p3 with: p4 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:56'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 of: aSelector on: anObject 
	<omniUnenforced>
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:56'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 of: aSelector on: anObject 
	<omniUnenforced>
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:56'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 of: aSelector on: anObject
	<omniUnenforced>
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:56'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8  of: aSelector on: anObject 
	<omniUnenforced>
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:56'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9  of: aSelector on: anObject 
	<omniUnenforced>
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:56'!
requestExecution: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10 of: aSelector on: anObject 
	<omniUnenforced>
	^ anObject baselevelPerform: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:57'!
requestExecutionOf: aSelector on: anObject
	<omniUnenforced>
	^ anObject baselevelPerform: aSelector! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 7/19/2012 22:54'!
requestExecutionOf: aSelector with: argArray lookup: cls on: anObject
	<omniUnenforced>
	^ anObject baselevelPerform: aSelector withArguments: argArray inSuperclass: cls.! !

!OstDomain methodsFor: 'omni-domain' stamp: 'StefanMarr 3/31/2012 18:28'!
spawnHere: aBlock
	"Spawn the given block as a process in this domain"	
	^ (self newProcessFor: aBlock) resume! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/2/2012 20:32'!
write: val toField: idx of: obj
	<omniUnenforced>
	"The calling convention is to return val,
	 i.e., the value stored into the object field."
	obj instVarAt: idx put: val.
	^ val! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/2/2012 20:33'!
write: val toField: idx of: obj return: returnValue
	<omniUnenforced>
	"The calling convention is to return 'val,
	 i.e., the value stored into the object field.'returnValue',
	 always!! This is to support the variations of the
	 store-to-object-field bytecodes in the OmniVM."
	obj instVarAt: idx put: val.
	^ returnValue! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/5/2012 20:47'!
write: val toLiteral: literal
	<omniUnenforced>
	"All globals are literals, and we treat all literals equal in the VM"
	"REM: same convention as for #write:toLiteral:  do return the value to be written "
	literal value: val.
	^ val! !

!OstDomain methodsFor: 'omni handlers' stamp: 'StefanMarr 8/5/2012 20:48'!
write: val toLiteral: literal return: returnValue
	<omniUnenforced>
	"All globals are literals, and we treat all literals equal in the VM"
	"REM: same convention as for #write:toLiteral:return:  do return the given returnValue"
	literal value: val.
	^ returnValue! !

Object subclass: #OstObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Misc'!

!OstObject commentStamp: 'StefanMarr 3/9/2012 21:08' prior: 0!
This is a compatibility class with the same name as what I got in the bytecode transformation-based implementation.!

OstObject subclass: #ONOWriteObject
	instanceVariableNames: 'i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15 i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31 i32 i33 i34 i35 i36 i37 i38 i39 i40 i41 i42 i43 i44 i45 i46 i47 i48 i49 i50 i51 i52 i53 i54 i55 i56 i57 i58 i59 i60 i61 i62 i63 i64 i65 i66 i67 i68 i69 i70'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniVMNoOpt-Core-Reflection-Tests'!

!ONOWriteObject methodsFor: 'test subjects' stamp: 'StefanMarr 8/3/2012 13:26'!
storeAndPop: obj
	i1 := obj! !

!ONOWriteObject methodsFor: 'test subjects' stamp: 'StefanMarr 8/3/2012 13:26'!
storeAndPopDoAnything: obj
	i70 := obj! !

!ONOWriteObject methodsFor: 'test subjects' stamp: 'StefanMarr 8/3/2012 16:43'!
storeAndPopDoAnythingUsingTopHandcrafted: obj
	i70 := obj.
	^ 42! !

!ONOWriteObject methodsFor: 'test subjects' stamp: 'StefanMarr 8/3/2012 13:26'!
storeAndPopExtended: obj
	i10 := obj! !

!ONOWriteObject methodsFor: 'test subjects' stamp: 'StefanMarr 8/3/2012 16:43'!
storeAndPopExtendedUsingTopHandcrafted: obj
	i10 := obj.
	^ 42! !

!ONOWriteObject methodsFor: 'test subjects' stamp: 'StefanMarr 8/3/2012 15:58'!
storeAndPopUsingTopHandcrafted: obj
	"This method is manually rewritten!!
	 see #setUp"
	i1 := obj.
	^ 42! !

!ONOWriteObject methodsFor: 'test subjects' stamp: 'StefanMarr 8/3/2012 13:26'!
storeWithoutPop: obj
	^ i1 := obj! !

!ONOWriteObject methodsFor: 'test subjects' stamp: 'StefanMarr 8/3/2012 13:27'!
storeWithoutPopDoAnything: obj
	^ i70 := obj! !

!ONOWriteObject methodsFor: 'test subjects' stamp: 'StefanMarr 8/3/2012 13:31'!
storeWithoutPopDoAnythingPostAdd: obj
	^ (i70 := obj) + 42! !

!ONOWriteObject methodsFor: 'test subjects' stamp: 'StefanMarr 8/3/2012 13:32'!
storeWithoutPopDoAnythingPreAdd: obj
	^ 42 + (i70 := obj)! !

!ONOWriteObject methodsFor: 'test subjects' stamp: 'StefanMarr 8/3/2012 13:26'!
storeWithoutPopExtended: obj
	^ i10 := obj! !

!ONOWriteObject methodsFor: 'test subjects' stamp: 'StefanMarr 8/3/2012 13:31'!
storeWithoutPopExtendedPostAdd: obj
	^ (i10 := obj) + 42! !

!ONOWriteObject methodsFor: 'test subjects' stamp: 'StefanMarr 8/3/2012 13:32'!
storeWithoutPopExtendedPreAdd: obj
	^ 42 + (i10 := obj)! !

!ONOWriteObject methodsFor: 'test subjects' stamp: 'StefanMarr 8/3/2012 13:31'!
storeWithoutPopPostAdd: obj
	^ (i1 := obj) + 42! !

!ONOWriteObject methodsFor: 'test subjects' stamp: 'StefanMarr 8/3/2012 13:32'!
storeWithoutPopPreAdd: obj
	^ 42 + (i1 := obj)! !

!OstObject class methodsFor: 'OmniST-compatibility' stamp: 'StefanMarr 3/22/2012 14:21'!
omnifyClass: aClass
	"Does not need to do anything for OmniVMNoOpt, the VM provides the support directly."
	^ aClass! !

!String methodsFor: '*OmniVMNoOpt-Tests-Compatibility-OmniST' stamp: 'StefanMarr 3/20/2012 20:38'!
asNormalSelector
	^ self asSymbol! !
OPromise initialize!
ONOMirror initialize!
ONOCompilerSupport initialize!
